unit ResourceUnit;

interface

  uses
    TomasResources,
    Tomas,
    Classes;

  Type
    TJob = class;
    TGenerator = class;

    TJob = class(TomasElement)
      public
      JobTime: Double;
      End;

    TGenerator = class(TomasElement)
      public
      InterArrivals: TExponentialDistribution;
      JobTimes: TExponentialDistribution;
      Published
      Constructor Create(Name: String);
      Procedure Process; override;
      End;

implementation

var
  Generator: TGenerator;
  Machine: TomasResource;
  MachineOutput: TList;

Constructor TGenerator.Create(Name: String);
Begin
  inherited Create(Name);
  InterArrivals:=TExponentialDistribution.Create(520623,30);
  JobTimes:=TExponentialDistribution.Create(1374617,24);
End;

Procedure TGenerator.Process;
var
  NewJob: TJob;
Begin
  While TRUE Do
  Begin
    NewJob:=TJob.Create('Job');
    NewJob.JobTime:=JobTimes.Sample;
    Machine.Claim(NewJob,1,NewJob.JobTime);
    Hold(InterArrivals.Sample);
  End;
End;

Procedure InitializeJobShop;
Begin
  MachineOutput:=TList.Create;
  Machine:=TomasResource.Create('Machine',0,1,FIFOSelect,MachineOutput);
  Generator:=TGenerator.Create('Generator');
  Generator.Start(TNow);
  TomasForm.SetTrace(TRUE);
End;

Initialization
  InitializeJobshop;


end.
